
#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
#include "UbidotsMicroESP8266.h"


extern "C" {
#include "ets_sys.h"
#include "os_type.h"
#include "osapi.h"
#include "mem.h"
#include "user_interface.h"
#include "cont.h"
}

#define TOKEN  "xlNtJF" //Ubidots token


#define RTC_WAKE_COUNT 67



uint32_t sleepCount=0; //this is the counter that keeps track of how many reboot cycles we have
int sleepFor = 15;
int maxIterations = 2880; //this is the max reboot cycles before an alive signal is sent to Ubidots
                          //every cycle is 15 seconds, which yields 15*2880=43200(seconds), divided by 3600
                          //gives you a total of 12 hours between "I am alive" signals

      
//Wifi settings
const char* ssid = "i";
const char* password = "ju";
Ubidots client(TOKEN);



void setup() {
  Serial.begin(9600);
  Serial.println("Booting");
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  delay(5000);
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
    Serial.println("Connection Failed! Rebooting...");
    delay(5000);
    ESP.restart();
  }


  ArduinoOTA.onStart([]() {
    Serial.println("Start");
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\nEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) Serial.println("Auth Failed");
    else if (error == OTA_BEGIN_ERROR) Serial.println("Begin Failed");
    else if (error == OTA_CONNECT_ERROR) Serial.println("Connect Failed");
    else if (error == OTA_RECEIVE_ERROR) Serial.println("Receive Failed");
    else if (error == OTA_END_ERROR) Serial.println("End Failed");
  });
  ArduinoOTA.begin();
  Serial.println("Ready");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
}

void loop() {
  //ArduinoOTA.handle();
    float value = analogRead(A0);
    Serial.println(value);
    if(value >= 5)
    { 
       
      client.add("ANALOG PIN A0", value);
      
      
      client.sendAll(true);
    }
 

    else 
    {
        client.add("ANALOG PIN A0", value);
        client.sendAll(true);
        sleepCount=0;

    }
    
    Serial.println("Completed loop, now going to sleep for 15 seconds");
    ESP.deepSleep(sleepFor * 1000000);
}
